package ca.carleton.gcrc.onUpload;

import java.sql.Connection;

import javax.servlet.ServletConfig;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;

import org.apache.log4j.Logger;

import ca.carleton.gcrc.contributions.Contributions;
import ca.carleton.gcrc.contributions.ContributionsUtils;
import ca.carleton.gcrc.jdbc.JdbcConnections;
import ca.carleton.gcrc.upload.OnUploadedListenerSingleton;
import ca.carleton.gcrc.upload.UploadServlet;

@SuppressWarnings("serial")
public class OnUploadConfigServlet extends HttpServlet {

	final protected Logger logger = Logger.getLogger(this.getClass());
	
	private Connection connection = null;
	private JdbcConnections connections = null;
	private Contributions contributions;

	@Override
	public void init(ServletConfig config) throws ServletException {
		super.init(config);

		try {
			connections = JdbcConnections.connectionsFromServletContext(config.getServletContext());
			connection = connections.getDb();
		} catch (Exception e) {
			throw new ServletException("Error while connecting to database",e);
		}
		contributions = ContributionsUtils.createContibutionHandler(config, connection);
		if (null == contributions) {
			return;
		}
		
		OnUpload onUpload = new OnUpload(config);
		onUpload.setContributions(contributions);
		config.getServletContext().setAttribute(UploadServlet.OnUploadedListenerAttributeName, onUpload);
		OnUploadedListenerSingleton.configure(onUpload);
		
		logger.info("Configured onUpload: "+this.getClass().getSimpleName());
	}

	@Override
	public void destroy() {
		super.destroy();
	}
}
